{ config, lib, ... }:
{
  networking.nftables.tables.forwarding = {
    family = "inet";
    content = ''
      chain PREROUTING {
        type nat hook prerouting priority dstnat; policy accept;
        tcp dport 2211 dnat ip to ${config.ips.pc}:22 comment "SSH to PC"
        
        udp dport { 27005, 27015, 7777 } dnat ip to ${config.ips.pc} comment "PC Hosted Games"
        
        tcp dport { 48010, 47989, 47984 } dnat ip to ${config.ips.pc} comment "PC Sunshine TCP"
        udp dport { 47998, 47999, 48000 } dnat ip to ${config.ips.pc} comment "PC Sunshine UDP"
        
        tcp dport { 38010, 37989, 37984 } dnat ip to ${config.ips.vm} comment "VM Sunshine TCP"
        udp dport { 37998, 37999, 38000 } dnat ip to ${config.ips.vm} comment "VM Sunshine UDP"
        
        udp dport { 7790, 7791, 7792 } dnat ip to ${config.ips.hx} comment "Deus Ex"
      }

      chain POSTROUTING {
        type nat hook postrouting priority 100; policy accept;
        oifname "enp0s31f6" masquerade
      }
    '';
  };

  # Enable IP forwarding for the server configuration
  boot.kernel.sysctl."net.ipv4.ip_forward" = 1;
}
